﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataTransmission.Entity;
public interface IWorkflow
{
	string? WorkflowId { get; set; }

	/// <summary>
	/// 过期时间配置id
	/// </summary>
	string? ExpiredTimeConfigId { get; set; }

	/// <summary>
	/// 流经部门
	/// </summary>
	List<string> FlowedOrgIds { get; set; }

	/// <summary>
	/// 流经办理人
	/// </summary>
	List<string> FlowedUserIds { get; set; }

	#region 当前办理对象

	/// <summary>
	/// 办理人id
	/// </summary>
	public List<HandlerGroupItem> HandlerUsers { get; set; }

	/// <summary>
	/// 办理部门id
	/// </summary>
	public List<HandlerGroupItem> HandlerOrgs { get; set; }

	#endregion
}

public enum EFlowAssignType
{
	/// <summary>
	/// 指派到部门
	/// </summary>
	Org = 0,

	/// <summary>
	/// 指派到用户
	/// </summary>
	User = 1,

	/// <summary>
	/// 指派到角色
	/// </summary>
	Role = 2,

	/// <summary>
	/// 指派到指定部门的指定角色
	/// </summary>
	OrgAndRole = 3,
}

/// <summary>
/// 办理对象分组（以办理step分组，多人办理一个step为一组）
/// </summary>
public class HandlerGroupItem
{
	public string GroupId { get; set; }

	public string Key { get; set; }

	public string Value { get; set; }
}