﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataTransmission.Enum
{
	public class Order 
	{
	}
	/// <summary>
	/// 时间类型
	/// </summary>
	public enum ETimeType
	{
		[Description("小时")]
		Hour = 1,
		[Description("工作日")]
		WorkDay = 2,
		[Description("自然日")]
		Day = 3,
	}
	public enum EOrderStatus
	{
		/// <summary>
		/// 待受理
		/// </summary>
		[Description("待受理")]
		WaitForAccept = 0,

		/// <summary>
		/// 已开启流程,退回到开始节点
		/// 待受理，可编辑
		/// </summary>
		[Description("退回待受理")]
		BackToUnAccept = 1,

		/// <summary>
		/// 已开启流程,特提到开始节点
		/// 待受理，可编辑
		/// </summary>
		[Description("特提待受理")]
		SpecialToUnAccept = 2,

		/// <summary>
		/// 已开启流程,移交开始节点
		/// 待受理，可编辑
		/// </summary>
		[Description("移交待受理")]
		HandOverToUnAccept = 3,

		/// <summary>
		/// 退回省平台（锁定，不可操作）
		/// </summary>
		[Description("退回省平台")]
		BackToProvince = 9,

		/// <summary>
		/// 办理中
		/// </summary>
		[Description("办理中")]
		Handling = 100,

		/// <summary>
		/// 特提信件
		/// </summary>
		[Description("特提信件")]
		Special = 101,

		/// <summary>
		/// 退回信件
		/// </summary>
		[Description("退回信件")]
		SendBack = 102,

		/// <summary>
		/// 移交信件
		/// </summary>
		[Description("移交信件")]
		HandOver = 103,

		/// <summary>
		/// 特提审批中
		/// </summary>
		[Description("特提审批中")]
		SpecialAudit = 104,

		/// <summary>
		/// 退回审批中
		/// </summary>
		[Description("退回审批中")]
		SendBackAudit = 105,

		/// <summary>
		/// 会签中
		/// </summary>
		[Description("会签中")]
		Countersigning = 200,

		/// <summary>
		/// 已归档
		/// </summary>
		[Description("已归档")]
		Filed = 300,

		/// <summary>
		/// 已发布
		/// </summary>
		[Description("已发布")]
		Published = 400,

		/// <summary>
		/// 已回访
		/// </summary>
		[Description("已回访")]
		Visited = 500,
	}

	/// <summary>
	/// 性别
	/// </summary>
	public enum EGender
	{
		[Description("女士")]
		Female = 0,

		[Description("先生")]
		Male = 1,

		[Description("未知")]
		Unknown = 2,
	}

	/// <summary>
	/// 来电/信人身份
	/// </summary>
	public enum EIdentityType
	{
		///// <summary>
		///// 未知
		///// </summary>
		//[Description("未知")]
		//Unknown = 0,

		/// <summary>
		/// 市民
		/// </summary>
		[Description("市民")]
		Citizen = 1,

		/// <summary>
		/// 企业
		/// </summary>
		[Description("企业")]
		Enterprise = 2,
	}

	public enum ESeatEvaluate
	{
		/// <summary>
		/// 默认满意
		/// </summary>
		[Description("默认满意")]
		DefaultSatisfied = 0,
		/// <summary>
		/// 非常不满意
		/// </summary>
		[Description("非常不满意")]
		VeryNoSatisfied = 1,

		/// <summary>
		/// 不满意
		/// </summary>
		[Description("不满意")]
		NoSatisfied = 2,

		/// <summary>
		/// 一般
		/// </summary>
		[Description("一般")]
		Normal = 3,

		/// <summary>
		/// 满意
		/// </summary>
		[Description("满意")]
		Satisfied = 4,

		/// <summary>
		/// 非常满意
		/// </summary>
		[Description("非常满意")]
		VerySatisfied = 5,

		/// <summary>
		/// 未接通
		/// </summary>
		[Description("未接通")]
		NoConnect = 6,

		/// <summary>
		/// 未做评价
		/// </summary>
		[Description("未做评价")]
		NoEvaluate = 7,
	}

	/// <summary>
	/// 会签类型
	/// </summary>
	public enum ECounterSignType
	{
		/// <summary>
		/// 中心会签
		/// </summary>
		[Description("中心会签")]
		Center = 0,

		/// <summary>
		/// 部门会签
		/// </summary>
		[Description("部门会签")]
		Department = 1,
	}

	public enum EExpiredStatus
	{
		/// <summary>
		/// 正常状态（未超期）
		/// </summary>
		[Description("正常")]
		Normal = 0,

		/// <summary>
		/// 即将超期
		/// </summary>
		[Description("剩余时间小于20%")]
		GoingToExpired = 1,

		/// <summary>
		/// 已超期
		/// </summary>
		[Description("已超期")]
		Expired = 2,

		/// <summary>
		/// 即将超期
		/// </summary>
		[Description("剩余时间小于50%")]
		GoingToExpiredOne = 3,
	}

	/// <summary>
	/// 工单处理方式（直办、交办）
	/// </summary>
	public enum EProcessType
	{
		/// <summary>
		/// 直接办结
		/// 中心
		/// </summary>
		Zhiban = 10,

		/// <summary>
		/// 交办
		/// 部门
		/// </summary>
		Jiaoban = 20,
	}

	public enum ESource
	{
		/// <summary>
		/// 热线平台工单
		/// </summary>
		Hotline = 0,

		/// <summary>
		/// 门户网站
		/// </summary>
		WebPortal = 2,

		/// <summary>
		/// APP
		/// </summary>
		APP = 3,

		/// <summary>
		/// 微信
		/// </summary>
		WeChat = 4,

		/// <summary>
		/// 热线平台导入工单
		/// </summary>
		HotlineImport = 1,

		/// <summary>
		/// 省平台直派
		/// </summary>
		ProvinceStraight = 100,

		/// <summary>
		/// 110同步工单
		/// </summary>
		Police110 = 200,

		/// <summary>
		/// 市州互转--泸州 
		/// </summary>
		CityDataExchangeLz = 300,

		/// <summary>
		/// 市州互转--宜宾
		/// </summary>
		CityDataExchangeYB = 301,

		/// <summary>
		/// 市州互转--自贡
		/// </summary>
		CityDataExchangeZG = 302,

		/// <summary>
		/// 市州互转--内江
		/// </summary>
		CityDataExchangeNJ = 303,

		/// <summary>
		/// 宜宾融媒体
		/// </summary>
		ConvergenceMedia = 400,

		/// <summary>
		/// i宜宾
		/// </summary>
		IYIBIN = 401,

		/// <summary>
		/// 智慧宜宾
		/// </summary>
		ZHYB = 402,

		/// <summary>
		/// 综治平台
		/// </summary>
		ZZPT = 403,

		/// <summary>
		/// 网络理政—市民中心大厅
		/// </summary>
		WLLZ = 404,

		/// <summary>
		/// 宜办事
		/// </summary>
		YBS = 405,

		/// <summary>
		/// 自贡观察
		/// </summary>
		ZGGC = 406,

		/// <summary>
		/// 天府通办
		/// </summary>
		ZGTFTB = 407,

		#region 导入类型（>=500  <530为导入来源）
		/// <summary>
		/// 麻辣社区导入
		/// </summary>
		[Description("麻辣社区")]
		MLSQ = 500,

		/// <summary>
		/// 人民网
		/// </summary>
		[Description("人民网")]
		RMW = 501,

		/// <summary>
		/// 省长信箱
		/// </summary>
		[Description("省长信箱")]
		SZXX = 502,

		/// <summary>
		/// 问政四川
		/// </summary>
		[Description("问政四川")]
		WZSC = 529,
		#endregion
	}
	public enum ERealCommunicationMode
	{
		[Description("电话")]
		Phone = 0,
		[Description("现场")]
		Locale = 1,
	}
	public enum EFileUserType
	{
		/// <summary>
		/// 坐席
		/// </summary>
		[Description("坐席")]
		Seat = 1,

		/// <summary>
		/// 派单员
		/// </summary>
		[Description("派单员")]
		Dispatch = 2,

		/// <summary>
		/// 部门
		/// </summary>
		[Description("部门")]
		Org = 3,
	}

	public class Kv
	{
		public Kv()
		{
		}

		public Kv(string key, string value)
		{
			Key = key;
			Value = value;
		}

		public string Key { get; set; }
		public string Value { get; set; }
	}

	#region Delay
	public enum EDelayState
	{
		/// <summary>
		/// 审批中
		/// </summary>
		[Description("审批中")]
		Examining = 0,

		/// <summary>
		/// 通过
		/// </summary>
		[Description("通过")]
		Pass = 1,

		/// <summary>
		/// 拒绝
		/// </summary>
		[Description("拒绝")]
		NoPass = 2,

		/// <summary>
		/// 撤销
		/// </summary>
		[Description("撤销")]
		Withdraw = 3,
	}

	public enum EDelayApplyType
	{
		[Description("本地审批")]
		LocalApply = 0,

		[Description("省审批")]
		ProvinceApply = 1,
	}
	#endregion

	#region Visit
	public enum EVisitState
	{
		/// <summary>
		/// 待回访
		/// </summary>
		[Description("待回访")]
		WaitForVisit = 10,

		/// <summary>
		/// 回访中
		/// </summary>
		[Description("回访中")]
		Visiting = 20,

		/// <summary>
		/// 短信回访中
		/// 逻辑需求(Task_317) : 操作了短信回访的工单，在没有短信结果回复前，回访状态需从“待回访”更新为“短信回访中”
		/// </summary>
		[Description("短信回访中")]
		SMSVisiting = 21,

		/// <summary>
		/// 智能回访中
		/// </summary>
		[Description("智能回访中")]
		AiVisiting = 22,

		/// <summary>
		/// 已回访
		/// </summary>
		[Description("已回访")]
		Visited = 30,

		/// <summary>
		/// 不满意待回访
		/// </summary>
		[Description("不满意待回访")]
		NoSatisfiedWaitForVisit = 40,

		/// <summary>
		/// 短信不满意待回访
		/// 逻辑需求(Task_317) : 若短信回访结果为不满意，回访状态需从“短信回访中”更新为“短信不满意待回访”
		/// </summary>
		[Description("短信不满意待回访")]
		SMSUnsatisfied = 41,

		/// <summary>
		/// 失效
		/// </summary>
		[Description("失效")]
		None = 50,
	}

	public enum EJudgeState
	{
		/// <summary>
		/// 评判中
		/// </summary>
		[Description("评判中")]
		Judging = 0,
		/// <summary>
		/// 已同意
		/// </summary>
		[Description("已同意")]
		Agreed = 1,
		/// <summary>
		/// 不同意
		/// </summary>
		[Description("不同意")]
		UnAgreed = 2,
	}

	public enum EVisitType
	{
		/// <summary>
		/// 人工回访
		/// </summary>
		[Description("人工回访")]
		ArtificialVisit = 10,

		/// <summary>
		/// 智能语音回访
		/// </summary>
		[Description("智能语音回访")]
		ChipVoiceVisit = 20,

		/// <summary>
		/// 短信回访
		/// </summary>
		[Description("短信回访")]
		SmsVisit = 30,

		/// <summary>
		/// 网站回访
		/// </summary>
		[Description("网站回访")]
		WebVisit = 40,

		/// <summary>
		/// App回访
		/// </summary>
		[Description("App回访")]
		AppVisit = 50,

		/// <summary>
		/// 微信回访
		/// </summary>
		[Description("微信回访")]
		WeChatVisit = 60,

		/// <summary>
		/// 电话回访
		/// </summary>
		[Description("电话回访")]
		CallVisit = 70,

		/// <summary>
		/// 其他
		/// </summary>
		[Description("其他")]
		OtherVisit = 100,
	}

	public enum EAiVisitResult
	{
		/// <summary>
		/// 部门办件不满意
		/// </summary>
		[Description("部门办件不满意")]
		OrgProcessingResultsNoSatisfied = 1,
	}

	public enum EVoiceEvaluate
	{
		/// <summary>
		/// 甄别为满意
		/// </summary>
		[Description("甄别为满意")]
		ScreenSatisfied = -1,

		/// <summary>
		/// 非常不满意
		/// </summary>
		[Description("非常不满意")]
		VeryNoSatisfied = 1,

		/// <summary>
		/// 不满意
		/// </summary>
		[Description("不满意")]
		NoSatisfied = 2,

		/// <summary>
		/// 一般
		/// </summary>
		[Description("一般")]
		Normal = 3,

		/// <summary>
		/// 满意
		/// </summary>
		[Description("满意")]
		Satisfied = 4,

		/// <summary>
		/// 非常满意
		/// </summary>
		[Description("非常满意")]
		VerySatisfied = 5,

		/// <summary>
		/// 未做评价
		/// </summary>
		[Description("未做评价")]
		NoEvaluate = 7,

		/// <summary>
		/// 未接通
		/// </summary>
		[Description("未接通")]
		BlockCall = 8,

		/// <summary>
		/// 默认满意
		/// </summary>
		[Description("默认满意")]
		DefaultSatisfied = 9,
	}

	public enum EVisitTarget
	{
		/// <summary>
		/// 话务员
		/// </summary>
		[Description("话务员")]
		Seat = 10,

		/// <summary>
		/// 部门
		/// </summary>
		[Description("部门")]
		Org = 20,
	}

	public enum EAgainState
	{
		/// <summary>
		/// 不重办
		/// </summary>
		[Description("不重办")]
		NoAgain = 0,

		/// <summary>
		/// 需要重办
		/// </summary>
		[Description("需要重办")]
		NeedAgain = 10,

		/// <summary>
		/// 已重办
		/// </summary>
		[Description("已重办")]
		DoAgain = 20,
	}
	#endregion

	#region Screen
	public enum EScreenStatus
	{
		/// <summary>
		/// 待办
		/// </summary>
		[Description("待办")]
		Apply = 0,

		/// <summary>
		/// 审批中
		/// </summary>
		[Description("甄别中")]
		Approval = 1,

		/// <summary>
		/// 审批完成
		/// </summary>
		[Description("甄别同意")]
		End = 2,

		/// <summary>
		/// 审批拒绝
		/// </summary>
		[Description("甄别不同意")]
		Refuse = 3,

		/// <summary>
		/// 已办 只用作列表查询使用
		/// </summary>
		[Description("已办")]
		MyHandle = 4,

		/// <summary>
		/// 退回
		/// </summary>
		[Description("甄别退回")]
		SendBack = 5,
	}

	public enum EOrderScreenType
	{
		/// <summary>
		/// 部门办件
		/// </summary>
		[Description("部门办件")]
		Org = 0,

		/// <summary>
		/// 中心话务
		/// </summary>
		[Description("中心话务")]
		Seat = 1,
	}
	#endregion

	#region Step

	public enum EWorkflowStatus
	{
		Runnable = 0,
		Suspended = 10,
		Completed = 20,
		Terminated = 30,
	}


	/// <summary>
	/// 流程类型
	/// </summary>
	public enum EFlowType
	{
		/// <summary>
		/// 办理
		/// </summary>
		[Description("办理")]
		Handle = 0,

		/// <summary>
		/// 审核
		/// </summary>
		[Description("审核")]
		Review = 10,
	}

	/// <summary>
	/// 节点状态
	/// </summary>
	public enum EWorkflowStepStatus
	{
		/// <summary>
		/// 待受理
		/// </summary>
		[Description("待受理")]
		WaitForAccept = 0,

		/// <summary>
		/// 待办理（已受理）
		/// </summary>
		[Description("待办理")]
		WaitForHandle = 1,

		/// <summary>
		/// 已办理
		/// </summary>
		[Description("已办理")]
		Handled = 2,

		///// <summary>
		///// 无需办理（或签流程未办理节点）
		///// </summary>
		//[Description("无需办理")]
		//NoNeedInSingleCountersign = 3,

		///// <summary>
		///// 未办理，由结束会签结束掉
		///// </summary>
		//[Description("已办理")]
		//Terminal = 3,
	}

	/// <summary>
	/// 节点处于会签流程中的位置
	/// </summary>
	public enum ECountersignPosition
	{
		/// <summary>
		/// 无会签（未处于会签流程中，外层也无会签嵌套）
		/// </summary>
		None = 0,

		/// <summary>
		/// 办理会签（上级节点直接开启会签）
		/// </summary>
		Direct = 1,

		/// <summary>
		/// 本身不直接处于会签流程中，但外层有会签流程嵌套（非上级节点开启会签，当前节点会签并未结束）
		/// </summary>
		Indirect = 2,

		/// <summary>
		/// 会签汇总节点
		/// </summary>
		End = 3,
	}

	/// <summary>
	/// 办理方式
	/// </summary>
	public enum EHandleMode
	{
		/// <summary>
		/// 正常办理
		/// </summary>
		[Description("正常")]
		Normal = 0,

		/// <summary>
		/// 审核通过(审批流程特有)
		/// </summary>
		[Description("审核通过")]
		Approved = 20,

		/// <summary>
		/// 审核不通过(审批流程特有)
		/// </summary>
		[Description("审核不通过")]
		NotApproved = 21,

		/// <summary>
		/// 退回
		/// </summary>
		[Description("退回")]
		Previous = 100,

		/// <summary>
		/// 特提
		/// </summary>
		[Description("特提")]
		Recall = 200,

		/// <summary>
		/// 重办
		/// </summary>
		[Description("重办")]
		Redo = 201,
	}

	public enum EReviewResult
	{
		/// <summary>
		/// 未知
		/// </summary>
		[Description("未办理")]
		Unknown = 0,

		/// <summary>
		/// 通过
		/// </summary>
		[Description("同意")]
		Approval = 1,

		/// <summary>
		/// 审核失败
		/// </summary>
		[Description("不同意")]
		Failed = 2,
	}

	public enum EStepType
	{
		/// <summary>
		/// 普通节点
		/// </summary>
		[Description("普通节点")]
		Normal = 0,

		/// <summary>
		/// 开始节点（发起人）
		/// </summary>
		[Description("开始节点")]
		Start = 1,

		/// <summary>
		/// 结束节点
		/// </summary>
		[Description("结束节点")]
		End = 2,

		/// <summary>
		/// 意见汇总节点
		/// </summary>
		[Description("意见汇总节点")]
		Summary = 3,
	}

	public enum EBusinessType
	{
		/// <summary>
		/// 坐席节点
		/// </summary>
		[Description("坐席节点")]
		Seat = 0,

		/// <summary>
		/// 派单节点
		/// </summary>
		[Description("派单节点")]
		Send = 1,

		/// <summary>
		/// 部门节点
		/// </summary>
		[Description("部门节点")]
		Department = 2,

		/// <summary>
		/// 部门领导
		/// </summary>
		[Description("部门领导节点")]
		DepartmentLeader = 3,

		/// <summary>
		/// 归档节点
		/// </summary>
		[Description("归档节点")]
		File = 99,
	}

	public enum EHandlerType
	{
		/// <summary>
		/// 角色
		/// </summary>
		[Description("角色")]
		Role = 0,

		/// <summary>
		/// 部门级别
		/// </summary>
		[Description("部门级别")]
		OrgLevel = 1,

		/// <summary>
		/// 部门类型
		/// </summary>
		[Description("部门类型")]
		OrgType = 2,

		/// <summary>
		/// 指定用户
		/// </summary>
		[Description("指定用户")]
		AssignedUser = 3,

		/// <summary>
		/// 指定部门
		/// </summary>
		[Description("指定部门")]
		AssignedOrg = 4,

		//   /// <summary>
		//   /// 指定部门与角色
		//   /// </summary>
		//   [Description("指定部门与角色")]
		//AssignedOrgOrRole = 5,
	}

	/// <summary>
	/// 执行模式
	/// </summary>
	public enum EExecuteMode
	{
		[Description("人工审批")]
		Manual = 0,

		[Description("自动通过")]
		AutoPass = 1,

		[Description("自动拒绝")]
		AutoReject = 2,
	}

	/// <summary>
	/// 动态实例化策略
	/// </summary>
	public enum ECountersignPolicy
	{
		/// <summary>
		/// 直属上级部门（中心作为顶级部门）
		/// </summary>
		[Description("直属上级（中心作为顶级部门）")]
		OrgUpCenterTop = 0,

		/// <summary>
		/// 直属上级（中心作为一级部门）
		/// </summary>
		[Description("直属上级（中心作为一级部门）")]
		OrgUp = 1,

		/// <summary>
		/// 直属下级部门（中心作为顶级部门）
		/// </summary>
		[Description("直属下级（中心作为顶级部门）")]
		OrgDownCenterTop = 2,

		/// <summary>
		/// 直属下级（中心作为一级部门）
		/// </summary>
		[Description("直属下级（中心作为一级部门）")]
		OrgDown = 3,
		// /// <summary>
		// /// 直属上级部门（中心作为顶级部门）经办人
		// /// </summary>
		// [Description("直属上级（中心作为顶级部门） 经办人")]
		// OrgUpHandleCenterTop = 4,
		//
		// /// <summary>
		// /// 直属上级（中心作为一级部门）
		// /// </summary>
		// [Description("直属上级（中心作为一级部门）经办人")]
		// OrgUpHandle = 5,
		//
		// /// <summary>
		// /// 直属上级部门（中心作为顶级部门） 经办人与领导
		// /// </summary>
		// [Description("直属上级（中心作为顶级部门）经办人与领导")]
		// OrgUpLeadCenterTop = 6,
		//
		// /// <summary>
		// /// 直属上级（中心作为一级部门）经办人与领导
		// /// </summary>
		// [Description("直属上级（中心作为一级部门）经办人与领导")]
		// OrgUpLead = 7,
		//
		// /// <summary>
		// /// 直达中心
		// /// </summary>
		// [Description("直达中心")]
		// ArriveCenter = 8,
		//
		// /// <summary>
		// /// 直达一级部门
		// /// </summary>
		// [Description("直达一级部门")]
		// ArriveOneOrg = 9,
	}

	/// <summary>
	/// 实例化模式（依据模板实例化step的模式）
	/// </summary>
	public enum EInstanceMode
	{
		[Description("依据配置")]
		Config = 0,

		[Description("依据操作人动态生成")]
		Dynamic = 1
	}

	/// <summary>
	/// 动态实例化策略
	/// </summary>
	public enum EDynamicPolicy
	{
		/// <summary>
		/// 直属上级部门（中心作为顶级部门）
		/// </summary>
		[Description("直属上级（中心作为顶级部门）")]
		OrgUpCenterTop = 0,

		/// <summary>
		/// 直属上级（中心作为一级部门）
		/// </summary>
		[Description("直属上级（中心作为一级部门）")]
		OrgUp = 1,

		/// <summary>
		/// 直属下级部门（中心作为顶级部门）
		/// </summary>
		[Description("直属下级（中心作为顶级部门）")]
		OrgDownCenterTop = 2,

		/// <summary>
		/// 直属下级（中心作为一级部门）
		/// </summary>
		[Description("直属下级（中心作为一级部门）")]
		OrgDown = 3,

		/// <summary>
		/// 直属上级部门（中心作为顶级部门）经办人
		/// </summary>
		[Description("直属上级（中心作为顶级部门） 经办人")]
		OrgUpHandleCenterTop = 4,

		/// <summary>
		/// 直属上级（中心作为一级部门）
		/// </summary>
		[Description("直属上级（中心作为一级部门）经办人")]
		OrgUpHandle = 5,

		/// <summary>
		/// 直属上级部门（中心作为顶级部门） 经办人与领导
		/// </summary>
		[Description("直属上级（中心作为顶级部门）经办人与领导")]
		OrgUpLeadCenterTop = 6,

		/// <summary>
		/// 直属上级（中心作为一级部门）经办人与领导
		/// </summary>
		[Description("直属上级（中心作为一级部门）经办人与领导")]
		OrgUpLead = 7,

		/// <summary>
		/// 直达中心
		/// </summary>
		[Description("直达中心")]
		ArriveCenter = 8,

		/// <summary>
		/// 直达一级部门
		/// </summary>
		[Description("直达一级部门")]
		ArriveOneOrg = 9,
	}

	public enum EFlowDirection
	{
		CenterToOrg = 0,

		OrgToCenter = 1,

		CenterToCenter = 2,

		OrgToOrg = 3,

		CenterToFile = 4,

		OrgToFile = 5,

		/// <summary>
		/// 已归档回到中心
		/// </summary>
		FiledToCenter = 6,

		/// <summary>
		/// 已归档回到部门
		/// </summary>
		FiledToOrg = 7
	}

	public enum EWorkflowTraceType
	{
		///// <summary>
		///// 流程开始
		///// </summary>
		//[Description("流程开始")]
		//Start = 0,

		/// <summary>
		/// 正常流转
		/// </summary>
		[Description("正常流转")]
		Normal = 1,

		/// <summary>
		/// 特提
		/// </summary>
		[Description("特提")]
		Recall = 2,

		/// <summary>
		/// 退回
		/// </summary>
		[Description("退回")]
		Previous = 3,

		/// <summary>
		/// 跳转
		/// </summary>
		[Description("跳转")]
		Jump = 4,

		/// <summary>
		/// 撤销（发起人操作）
		/// </summary>
		[Description("撤销")]
		Cancel = 5,

		/// <summary>
		/// 重办
		/// </summary>
		[Description("重办")]
		Redo = 6,

		/// <summary>
		/// 二次办理
		/// </summary>
		[Description("二次办理")]
		SecondHandle = 7,
	}

	/// <summary>
	/// 快照对应节点状态
	/// </summary>
	public enum EWorkflowTraceState
	{
		/// <summary>
		/// 正常办理
		/// </summary>
		Normal = 0,

		/// <summary>
		/// 对应节点因退回被删除
		/// </summary>
		StepRemoveByPrevious = 10,

		/// <summary>
		/// 对应节点因特提被删除(工单未归档)
		/// </summary>
		StepRemoveByRecall = 20,

		/// <summary>
		/// 对应节点因特提被删除(工单已归档)
		/// </summary>
		StepRemoveByRecallWhenFiled = 21,
	}

	/// <summary>
	/// 流程节点类型
	/// </summary>
	public enum ETraceStyle
	{
		/// <summary>
		/// 流程节点
		/// </summary>
		Flow = 0,

		/// <summary>
		/// 发布
		/// </summary>
		Publish = 1,

		/// <summary>
		/// 回访
		/// </summary>
		Visit = 2,

		/// <summary>
		/// 结束（为了与老系统保持一致，额外添加在回访后的节点）
		/// </summary>
		TrashEnd = 9,
	}
	#endregion

	#region Call
	/// <summary>
	/// 呼叫状态
	/// 兴唐状态: 0: 留言; 1: 队列等待超时; 2: 坐席振铃超时; 3: 未接; 4: 满意度; 5: 通话; 6: IVR; 7: 振铃挂机; 8: 分机互打挂机; 9: ASR交互;
	/// </summary>
	public enum ECallState
	{
		/// <summary>
		/// 无效
		/// 兴唐: SkillId = 0
		/// </summary>
		[Description("无效")]
		Invalid = 0,

		/// <summary>
		/// 接通
		/// 兴唐: 状态: 0, 4, 5, 8
		/// </summary>
		[Description("接通")]
		On = 1,

		/// <summary>
		/// 未接
		/// 兴唐 状态: 2 , 3, 7
		/// </summary>
		[Description("未接")]
		Missed = 2,

		/// <summary>
		/// 呼入队列挂断
		/// 兴唐 状态: 1
		/// </summary>
		[Description("呼入队列挂断")]
		NotAcceptedHang = 3,


		/// <summary>
		/// IVR挂断
		/// 兴唐 状态: 6
		/// </summary>
		[Description("IVR挂断")]
		IVRNoAccept = 5
	}

	/// <summary>
	/// 通话结束方
	/// </summary>
	public enum EEndBy
	{
		/// <summary>
		/// 主叫方结束
		/// </summary>
		[Description("主叫方结束")]
		From = 0,

		/// <summary>
		/// 被叫方结束
		/// </summary>
		[Description("被叫方结束")]
		To = 1,

		/// <summary>
		/// 其他位置情况
		/// </summary>
		[Description("其他未知情况")]
		None = 2,
	}

	/// <summary>
	/// 呼叫方向，来电/呼出
	/// </summary>
	public enum ECallDirection
	{
		/// <summary>
		/// 来电
		/// </summary>
		[Description("来电")]
		In = 0,

		/// <summary>
		/// 呼出
		/// </summary>
		[Description("呼出")]
		Out = 1,
	}

	public enum ECallTransliterationState
	{
		/// <summary>
		/// 未开始
		/// </summary>
		[Description("未开始")]
		NoBegin = 0,

		/// <summary>
		/// 进行中	
		/// </summary>
		[Description("进行中")]
		Underway = 1,

		/// <summary>
		/// 转写成功
		/// </summary>
		[Description("转写成功")]
		Succeed = 2,

		/// <summary>
		/// 转写失败
		/// </summary>
		[Description("转写失败")]
		Fail = 3,
	}

	public enum EPhoneTypes
	{
		[Description("普通")]
		Ordinary = 0,

		[Description("呼入VIP")]
		CallInVip = 1,

		[Description("呼入黑名单")]
		CallInBlackList = 2,

		[Description("呼出黑名单")]
		CallOutBlackList = 3,

		[Description("呼入呼出黑名单")]
		CallIntAndOutBlackList = 4,
	}

	public enum ECallOrderType
	{
		[Description("工单")]
		Order = 1,
		[Description("回访")]
		Visit = 2,
	}

	public enum EOnState
	{
		/// <summary>
		/// 接通
		/// </summary>
		[Description("接通")]
		On = 1,

		/// <summary>
		/// 未接通
		/// </summary>
		[Description("未接通")]
		NoOn = 2,
	}
	#endregion

}
