﻿using Abp.Collections.Extensions;
using Hotline.Snapshot;
using Mapster;
using SnapshotWinFormsApp.Application.Dtos;
using SnapshotWinFormsApp.Application.Interfaces;
using SnapshotWinFormsApp.Entities.NewHotline;
using SnapshotWinFormsApp.Entities.OldHotline;
using SnapshotWinFormsApp.Repository;
using SnapshotWinFormsApp.Repository.Interfaces;
using SnapshotWinFormsApp.Tools;
using System.ComponentModel;
using System.Configuration;

namespace SnapshotWinFormsApp.Application;

[Description("邀请码")]
public class InviteApplication : ImportApplicationBase<SSP_InviteEntity, InviteCode>, IImportApplication
{
    public InviteApplication(CreateInstanceInDto inDto) : base(inDto)
    {
    }

    public override async Task<InviteCode> GetTargetAsync(SSP_InviteEntity source, CancellationToken token)
    {
        var inviteCode = source.Adapt<InviteCode>();
        var url = ConfigurationManager.AppSettings["ZiGongFile"] + inviteCode.QRCodeUrl;
        var fileContent = await new FileTools().GetNetworkFileAsync(url, token);
        inviteCode.QRCodeUrl = fileContent.Path;
        inviteCode.CreationTime = DateTime.Now;
        return inviteCode;
    }
}
