﻿using Hotline.Settings;
using Mapster;
using SnapshotWinFormsApp.Application.Dtos;
using SnapshotWinFormsApp.Application.Interfaces;
using SnapshotWinFormsApp.Entities.NewHotline;
using SnapshotWinFormsApp.Entities.OldHotline;
using SnapshotWinFormsApp.Repository;
using SnapshotWinFormsApp.Repository.Interfaces;
using System.ComponentModel;

namespace SnapshotWinFormsApp.Application;

[Description("区域从业人员")]
public class PractitionerApplication : ImportApplicationBase<SSP_AreaUserEntity, Practitioner>, IImportApplication
{
    private readonly ISelectRepository<SystemArea> _systemAreaRepo;
    private IList<SystemArea> areas;
    public PractitionerApplication(CreateInstanceInDto inDto) : base(inDto)
    {
        _systemAreaRepo = new SelectRepository<SystemArea>(inDto);
        areas = _systemAreaRepo.GetAll();
    }

    public override async Task<Practitioner> GetTargetAsync(SSP_AreaUserEntity source, CancellationToken token)
    {
        var target = source.Adapt<Practitioner>();
        target.SystemAreaId = areas.FirstOrDefault(m => m.AreaName == source.AreaName)?.Id ?? string.Empty;
        return await Task.FromResult(target);
    }
}
