﻿using SqlSugar;
using System.ComponentModel;

namespace SnapshotWinFormsApp.Entities.NewHotline;

/// <summary>
/// 行业线索
/// </summary>
[SugarTable("industry_case")]
[Description("行业线索")]
public class IndustryCase : DataTransmission.Entity.CreationSoftDeleteEntity
{
    /// <summary>
    /// 行业Id
    /// </summary>
    [SugarColumn(ColumnDescription = "行业Id")]
    public string IndustryId { get; set; }

    /// <summary>
    /// 线索名称
    /// </summary>
    [SugarColumn(ColumnDescription = "线索名称")]
    public string Name { get; set; }

    /// <summary>
    /// 市民发放红包金额(单位:元)
    /// </summary>
    [SugarColumn(ColumnDescription = "市民发放红包金额(单位:元)")]
    public double CitizenReadPackAmount { get; set; }

    /// <summary>
    /// 网络员发放红包金额(单位:元)
    /// </summary>
    [SugarColumn(ColumnDescription = "网络员发放红包金额(单位:元)")]
    public double GuiderReadPackAmount { get; set; }

    /// <summary>
    /// 是否启用
    /// </summary>
    [SugarColumn(ColumnDescription = "是否启用")]
    public bool IsEnable { get; set; }

    /// <summary>
    /// 排序
    /// </summary>
    [SugarColumn(ColumnDescription = "排序")]
    public int DisplayOrder { get; set; }

}
