﻿using SqlSugar;
using System.ComponentModel;

namespace SnapshotWinFormsApp.Entities.NewHotline;

/// <summary>
/// 积分记录
/// </summary>
[Description("积分记录")]
[SugarTable("snapshot_points_record")]
public class SnapshotPointsRecord : CreationEntity
{
    /// <summary>
    /// 用户Id
    /// </summary>
    public string UserId { get; set; }

    /// <summary>
    /// 方向
    /// </summary>
    public EPointsDirection Direction { get; set; }

    /// <summary>
    /// 积分来源
    /// </summary>
    public EPointsSource Source { get; set; }

    /// <summary>
    /// 积分
    /// </summary>
    public int Points { get; set; }

    public string OrderId { get; set; }
}

public enum EPointsDirection
{
    /// <summary>
    /// 收入
    /// </summary>
    [Description("收入")]
    In = 0,

    /// <summary>
    /// 支出
    /// </summary>
    [Description("支出")]
    Out = 1
}
