﻿using DataTransmission.Entity;
using SnapshotWinFormsApp.Repository.Enum;
using SqlSugar;
using System.ComponentModel;

namespace Hotline.Settings;

[Description("组织架构")]
[SugarTable("system_organize")]
public class SystemOrganize : CreationSoftDeleteEntity
{
    /// <summary>
    /// 组织架构名称
    /// </summary>
    [SugarColumn(ColumnDescription = "组织架构名称")]
    public string Name { get; set; }

    /// <summary>
    /// 组织架构简称
    /// </summary>
    [SugarColumn(ColumnDescription = "组织架构简称")]
    public string ShortName { get; set; }

    /// <summary>
    /// 区域Code（行政区域代码）
    /// </summary>
    [SugarColumn(ColumnDescription = "区域Code（行政区域代码）")]
    public string? AreaCode { get; set; }

    /// <summary>
    /// 区域名称（行政区域名称）
    /// </summary>
    [SugarColumn(ColumnDescription = "区域名称（行政区域名称）")]
    public string? AreaName { get; set; }

    /// <summary>
    /// 部门级别
    /// </summary>
    [SugarColumn(ColumnDescription = "部门级别")]
    public int Level { get; set; }

    /// <summary>
    /// 部门类型
    /// </summary>
    [SugarColumn(ColumnDescription = "部门类型")]
    public EOrgType OrgType { get; set; }

    /// <summary>
    /// 上级ID
    /// </summary>
    [SugarColumn(ColumnDescription = "上级ID")]
    public string? ParentId { get; set; }

    /// <summary>
    /// 上级名称
    /// </summary>
    [SugarColumn(ColumnDescription = "上级名称")]
    public string? ParentName { get; set; }

    /// <summary>
    /// 是否启用
    /// </summary>
    [SugarColumn(ColumnDescription = "是否启用")]
    public bool IsEnable { get; set; }

    /// <summary>
    /// 是否为中心
    /// </summary>
    [SugarColumn(ColumnDescription = "是否为中心")]
    public bool IsCenter { get; set; }

    [SugarColumn(IsIgnore = true)]
    public List<SystemOrganize> Children { get; set; }

    /// <summary>
    /// 旧系统id
    /// </summary>
    [SugarColumn(ColumnDescription = "旧系统id")]
    public int? oldBmid { get; set; }
}
