﻿using System.ComponentModel;
using DataTransmission.Enum;
using SqlSugar;

namespace SnapshotWinFormsApp.Entities.NewHotline
{
    /// <summary>
    /// 用户
    /// </summary>
    [SugarTable("user")]
    [Description("用户")]
    public class User : DataTransmission.Entity.CreationSoftDeleteEntity
    {
        /// <summary>
        /// 手机号(冗余)
        /// </summary>
        public string? PhoneNo { get; set; }

        /// <summary>
        /// 座机号码
        /// </summary>
        [SugarColumn(ColumnDescription = "座机号码", ColumnDataType = "varchar(50)")]
        public string? LandlineNumber { get; set; }

        /// <summary>
        /// 展示名称(Identity.DisplayName)
        /// </summary>
        public string Name { get; set; }

        public EGender Gender { get; set; }

        /// <summary>
        /// 工号
        /// </summary>
        public string? StaffNo { get; set; }

        /// <summary>
        /// 部门Id
        /// </summary>
        public string? OrgId { get; set; }

        /// <summary>
        /// 部门全称
        /// </summary>
        public string? FullOrgName { get; set; }

        /// <summary>
        /// 默认分机号
        /// </summary>
        public string? DefaultTelNo { get; set; }

        /// <summary>
        /// 默认分机组(技能组)
        /// </summary>
        public string? DefaultTelGroup { get; set; }

        /// <summary>
        /// 用户类型
        /// </summary>
        public EUserType UserType { get; set; }

        /// <summary>
        /// 旧系统用户id
        /// </summary>
        public int? OldUserId { get; set; }
    }
}

public enum EUserType
{
    [Description("普通")]
    Normal = 0,

    /// <summary>
    /// 坐席(统计需要)
    /// </summary>
    [Description("坐席")]
    Seat = 1,
}
