﻿using SqlSugar;

namespace SnapshotWinFormsApp.Entities.NewHotline;

/// <summary>
/// 工作流业务模块
/// </summary>
[SugarTable("workflow_module")]
public class WorkflowModule : DataTransmission.Entity.CreationEntity
{
    public WorkflowModule()
    {

    }

    public WorkflowModule(string code, string name, string remark = "")
    {
        Code = code;
        Name = name;
        Remark = remark;
    }

    /// <summary>
    /// WorkflowModuleConsts约定code
    /// </summary>
    public string Code { get; set; }

    public string Name { get; set; }

    public string Remark { get; set; } = string.Empty;

    /// <summary>
    /// 流程模板Id
    /// </summary>
    [SugarColumn(IsNullable = true)]
    public string? DefinitionId { get; set; }

    ///// <summary>
    ///// 模板名称（冗余）
    ///// </summary>
    //[SugarColumn(IsNullable = true)]
    //public string? DefinitionName { get; set; }

    ///// <summary>
    ///// 模板编码（冗余）
    ///// </summary>
    //[SugarColumn(IsNullable = true)]
    //public string? DefinitionCode { get; set; }

    ///// <summary>
    ///// 模板版本号（冗余）
    ///// </summary>
    //public int? DefinitionVersion { get; set; }
}